Index: trunk/NEMO/LIM_SRC_2/limrst_2.F90
===================================================================
--- trunk/NEMO/LIM_SRC_2/limrst_2.F90	(revision 873)
+++ trunk/NEMO/LIM_SRC_2/limrst_2.F90	(revision 888)
@@ -17,6 +17,6 @@
    !!----------------------------------------------------------------------
    USE ice_2
-   USE dom_oce
-   USE ice_oce         ! ice variables
+   USE sbc_oce
+   USE sbc_ice
    USE daymod
 
@@ -27,7 +27,7 @@
    PRIVATE
 
-   PUBLIC   lim_rst_opn_2     ! routine called by ??? module
-   PUBLIC   lim_rst_write_2   ! routine called by ??? module
-   PUBLIC   lim_rst_read_2    ! routine called by ??? module
+   PUBLIC   lim_rst_opn_2     ! routine called by sbcice_lim_2.F90
+   PUBLIC   lim_rst_write_2   ! routine called by sbcice_lim_2.F90
+   PUBLIC   lim_rst_read_2    ! routine called by iceini_2.F90
 
    LOGICAL, PUBLIC ::   lrst_ice         !: logical to control the ice restart write 
@@ -36,5 +36,5 @@
    !!----------------------------------------------------------------------
    !!   LIM 2.0,  UCL-LOCEAN-IPSL (2006) 
-   !! $Header: /home/opalod/NEMOCVSROOT/NEMO/LIM_SRC/limrst.F90,v 1.15 2007/06/29 14:54:06 opalod Exp $ 
+   !! $ Id: $
    !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
@@ -57,7 +57,7 @@
       
       ! to get better performances with NetCDF format:
-      ! we open and define the ice restart file one ice time step before writing the data (-> at nitrst - 2*nfice + 1)
-      ! except if we write ice restart files every ice time step or if an ice restart file was writen at nitend - 2*nfice + 1
-      IF( kt == nitrst - 2*nfice + 1 .OR. nstock == nfice .OR. ( kt == nitend - nfice + 1 .AND. .NOT. lrst_ice ) ) THEN
+      ! we open and define the ice restart file one ice time step before writing the data (-> at nitrst - 2*nn_fsbc + 1)
+      ! except if we write ice restart files every ice time step or if an ice restart file was writen at nitend - 2*nn_fsbc + 1
+      IF( kt == nitrst - 2*nn_fsbc + 1 .OR. nstock == nn_fsbc .OR. ( kt == nitend - nn_fsbc + 1 .AND. .NOT. lrst_ice ) ) THEN
          ! beware of the format used to write kt (default is i8.8, that should be large enough...)
          IF( nitrst > 99999999 ) THEN   ;   WRITE(clkt, *       ) nitrst
@@ -72,7 +72,7 @@
             CASE DEFAULT         ;   WRITE(numout,*) '             open ice restart NetCDF file: '//clname
             END SELECT
-            IF( kt == nitrst - 2*nfice + 1 ) THEN   
-               WRITE(numout,*)         '             kt = nitrst - 2*nfice + 1 = ', kt,' date= ', ndastp
-            ELSE   ;   WRITE(numout,*) '             kt = '                       , kt,' date= ', ndastp
+            IF( kt == nitrst - 2*nn_fsbc + 1 ) THEN   
+               WRITE(numout,*)         '             kt = nitrst - 2*nn_fsbc + 1 = ', kt,' date= ', ndastp
+            ELSE   ;   WRITE(numout,*) '             kt = '                         , kt,' date= ', ndastp
             ENDIF
          ENDIF
@@ -90,15 +90,15 @@
       !! ** purpose  :   output of sea-ice variable in a netcdf file
       !!----------------------------------------------------------------------
-      INTEGER, INTENT(in) ::   kt     ! number of iteration
-      !!
-      INTEGER ::   iter     ! kt + nfice -1
-      !!----------------------------------------------------------------------
-
-      iter = kt + nfice - 1   ! ice restarts are written at kt == nitrst - nfice + 1
+      INTEGER, INTENT(in) ::   kt   ! number of iteration
+      !
+      INTEGER ::   iter   ! kt + nn_fsbc -1
+      !!----------------------------------------------------------------------
+
+      iter = kt + nn_fsbc - 1   ! ice restarts are written at kt == nitrst - nn_fsbc + 1
 
       IF( iter == nitrst ) THEN
          IF(lwp) WRITE(numout,*)
          IF(lwp) WRITE(numout,*) 'lim_rst_write_2 : write ice restart file  kt =', kt
-         IF(lwp) WRITE(numout,*) '~~~~~~~'         
+         IF(lwp) WRITE(numout,*) '~~~~~~~~~~~~~~~'
       ENDIF
 
@@ -106,6 +106,5 @@
       ! ------------------ 
       !                                                                     ! calendar control
-      CALL iom_rstput( iter, nitrst, numriw, 'nfice' , REAL( nfice, wp) )      ! time-step 
-      CALL iom_rstput( iter, nitrst, numriw, 'kt_ice', REAL( iter , wp) )      ! date
+      CALL iom_rstput( iter, nitrst, numriw, 'kt_ice', REAL( iter, wp) ) 
       
       CALL iom_rstput( iter, nitrst, numriw, 'hicif' , hicif (:,:)   )      ! prognostic variables 
@@ -119,8 +118,6 @@
       CALL iom_rstput( iter, nitrst, numriw, 'tbif2' , tbif  (:,:,2) )
       CALL iom_rstput( iter, nitrst, numriw, 'tbif3' , tbif  (:,:,3) )
-      CALL iom_rstput( iter, nitrst, numriw, 'u_ice' , u_ice (:,:)   )
-      CALL iom_rstput( iter, nitrst, numriw, 'v_ice' , v_ice (:,:)   )
-      CALL iom_rstput( iter, nitrst, numriw, 'gtaux' , gtaux (:,:)   )
-      CALL iom_rstput( iter, nitrst, numriw, 'gtauy' , gtauy (:,:)   )
+      CALL iom_rstput( iter, nitrst, numriw, 'ui_ice', ui_ice(:,:)   )
+      CALL iom_rstput( iter, nitrst, numriw, 'vi_ice', vi_ice(:,:)   )
       CALL iom_rstput( iter, nitrst, numriw, 'qstoif', qstoif(:,:)   )
       CALL iom_rstput( iter, nitrst, numriw, 'fsbbq' , fsbbq (:,:)   )
@@ -175,6 +172,5 @@
       !! ** purpose  :   read of sea-ice variable restart in a netcdf file
       !!----------------------------------------------------------------------
-      !
-      REAL(wp) ::   zfice, ziter
+      REAL(wp) ::   ziter
       !!----------------------------------------------------------------------
 
@@ -182,12 +178,11 @@
          WRITE(numout,*)
          WRITE(numout,*) 'lim_rst_read_2 : read ice NetCDF restart file'
-         WRITE(numout,*) '~~~~~~~~'
+         WRITE(numout,*) '~~~~~~~~~~~~~~'
       ENDIF
 
       CALL iom_open ( 'restart_ice_in', numrir, kiolib = jprstlib )
 
-      CALL iom_get( numrir, 'nfice' , zfice )
-      CALL iom_get( numrir, 'kt_ice', ziter )    
-      IF(lwp) WRITE(numout,*) '   read ice restart file at time step    : ', ziter
+      CALL iom_get( numrir, 'kt_ice' , ziter )
+      IF(lwp) WRITE(numout,*) '   read ice restart file at time step    : ', INT( ziter )
       IF(lwp) WRITE(numout,*) '   in any case we force it to nit000 - 1 : ', nit000 - 1
 
@@ -196,8 +191,4 @@
       IF( ( nit000 - INT(ziter) ) /= 1 .AND. ABS( nrstdt ) == 1 )   &
          &     CALL ctl_stop( 'lim_rst_read ===>>>> : problem with nit000 in ice restart',  &
-         &                   '   verify the file or rerun with the value 0 for the',        &
-         &                   '   control of time parameter  nrstdt' )
-      IF( INT(zfice) /= nfice          .AND. ABS( nrstdt ) == 1 )   &
-         &     CALL ctl_stop( 'lim_rst_read ===>>>> : problem with nfice in ice restart',  &
          &                   '   verify the file or rerun with the value 0 for the',        &
          &                   '   control of time parameter  nrstdt' )
@@ -213,8 +204,6 @@
       CALL iom_get( numrir, jpdom_autoglo, 'tbif2' , tbif(:,:,2) )    
       CALL iom_get( numrir, jpdom_autoglo, 'tbif3' , tbif(:,:,3) )    
-      CALL iom_get( numrir, jpdom_autoglo, 'u_ice' , u_ice  )    
-      CALL iom_get( numrir, jpdom_autoglo, 'v_ice' , v_ice  )    
-      CALL iom_get( numrir, jpdom_autoglo, 'gtaux' , gtaux  )    
-      CALL iom_get( numrir, jpdom_autoglo, 'gtauy' , gtauy  )    
+      CALL iom_get( numrir, jpdom_autoglo, 'ui_ice', ui_ice )    
+      CALL iom_get( numrir, jpdom_autoglo, 'vi_ice', vi_ice )    
       CALL iom_get( numrir, jpdom_autoglo, 'qstoif', qstoif )    
       CALL iom_get( numrir, jpdom_autoglo, 'fsbbq' , fsbbq  )    
Index: trunk/NEMO/LIM_SRC_2/limsbc_2.F90
===================================================================
--- trunk/NEMO/LIM_SRC_2/limsbc_2.F90	(revision 888)
+++ trunk/NEMO/LIM_SRC_2/limsbc_2.F90	(revision 888)
@@ -0,0 +1,251 @@
+MODULE limsbc_2
+   !!======================================================================
+   !!                       ***  MODULE limsbc_2   ***
+   !!           computation of the flux at the sea ice/ocean interface
+   !!======================================================================
+   !! History : 00-01 (H. Goosse) Original code
+   !!           02-07 (C. Ethe, G. Madec) re-writing F90
+   !!           06-07 (G. Madec) surface module
+   !!----------------------------------------------------------------------
+#if defined key_lim2
+   !!----------------------------------------------------------------------
+   !!   'key_lim2'                                    LIM 2.0 sea-ice model
+   !!----------------------------------------------------------------------
+   !!----------------------------------------------------------------------
+   !!   lim_sbc_2  : flux at the ice / ocean interface
+   !!----------------------------------------------------------------------
+   USE par_oce          ! ocean parameters
+   USE dom_oce          ! ocean domain
+   USE sbc_ice          ! surface boundary condition
+   USE sbc_oce          ! surface boundary condition
+   USE phycst           ! physical constants
+   USE ocfzpt           ! surface ocean freezing point
+   USE ice_oce          ! sea-ice variable
+   USE ice_2            ! LIM sea-ice variables
+   USE iceini_2         ! ???
+   USE dynspg_oce       ! choice of the surface pressure gradient scheme 
+
+   USE lbclnk           ! ocean lateral boundary condition
+   USE in_out_manager   ! I/O manager
+   USE albedo           ! albedo parameters
+   USE prtctl           ! Print control
+
+   IMPLICIT NONE
+   PRIVATE
+
+   PUBLIC lim_sbc_2     ! called by sbc_ice_lim_2
+
+   REAL(wp)  ::   epsi16 = 1.e-16  ! constant values
+   REAL(wp)  ::   rzero  = 0.e0    
+   REAL(wp)  ::   rone   = 1.e0
+
+   !! * Substitutions
+#  include "vectopt_loop_substitute.h90"
+   !!----------------------------------------------------------------------
+   !!   LIM 2.0,  UCL-LOCEAN-IPSL (2006) 
+   !! $ Id: $
+   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
+
+CONTAINS
+
+   SUBROUTINE lim_sbc_2( kt )
+      !!-------------------------------------------------------------------
+      !!                ***  ROUTINE lim_sbc_2 ***
+      !!  
+      !! ** Purpose : Update surface ocean boundary condition over areas
+      !!      that are at least partially covered by sea-ice
+      !!         
+      !! ** Action  : - comput. of the momentum, heat and freshwater/salt
+      !!      fluxes at the ice-ocean interface.
+      !!              - Update 
+      !!     
+      !! ** Outputs : - qsr    : sea heat flux:     solar 
+      !!              - qns    : sea heat flux: non solar
+      !!              - emp    : freshwater budget: volume flux 
+      !!              - emps   : freshwater budget: concentration/dillution 
+      !!              - utau   : sea surface i-stress (ocean referential)
+      !!              - vtau   : sea surface j-stress (ocean referential)
+      !!
+      !! References : Goosse, H. et al. 1996, Bul. Soc. Roy. Sc. Liege, 65, 87-90.
+      !!              Tartinville et al. 2001 Ocean Modelling, 3, 95-108.
+      !!---------------------------------------------------------------------
+      INTEGER ::   kt    ! number of iteration
+      !!
+      INTEGER  ::   ji, jj           ! dummy loop indices
+      INTEGER  ::   ifvt, i1mfr, idfr               ! some switches
+      INTEGER  ::   iflt, ial, iadv, ifral, ifrdv
+      REAL(wp) ::   zqsr  , zqns     ! solar & non solar heat flux
+      REAL(wp) ::   zinda            ! switch for testing the values of ice concentration
+      REAL(wp) ::   zfons            ! salt exchanges at the ice/ocean interface
+      REAL(wp) ::   zemp             ! freshwater exchanges at the ice/ocean interface
+      REAL(wp) ::   zfrldu, zfrldv   ! lead fraction at U- & V-points
+      REAL(wp) ::   zutau , zvtau    ! lead fraction at U- & V-points
+      REAL(wp) ::   zu_io , zv_io    ! 2 components of the ice-ocean velocity
+#if defined key_coupled    
+      REAL(wp), DIMENSION(jpi,jpj) ::   zalb     ! albedo of ice under overcast sky
+      REAL(wp), DIMENSION(jpi,jpj) ::   zalbp    ! albedo of ice under clear sky
+#endif
+      REAL(wp) ::   zsang, zmod, zfm
+      REAL(wp), DIMENSION(jpi,jpj) ::   ztio_u, ztio_v   ! ocean stress below sea-ice
+
+      !!---------------------------------------------------------------------
+     
+      IF( kt == nit000 ) THEN
+         IF(lwp) WRITE(numout,*)
+         IF(lwp) WRITE(numout,*) 'lim_sbc_2 : LIM 2.0 sea-ice - surface boundary condition'
+         IF(lwp) WRITE(numout,*) '~~~~~~~~~   '
+      ENDIF
+
+      !------------------------------------------!
+      !      heat flux at the ocean surface      !
+      !------------------------------------------!
+
+!!gm
+!!gm CAUTION   
+!!gm re-verifies the non solar expression, especially over open ocen
+!!gm
+      DO jj = 1, jpj
+         DO ji = 1, jpi
+            zinda   = 1.0   - MAX( rzero , SIGN( rone, - ( 1.0 - pfrld(ji,jj) )   ) )
+            ifvt    = zinda * MAX( rzero , SIGN( rone,  - phicif(ji,jj)           ) )
+            i1mfr   = 1.0   - MAX( rzero , SIGN( rone, - ( 1.0 - frld(ji,jj) )    ) )
+            idfr    = 1.0   - MAX( rzero , SIGN( rone, frld(ji,jj) - pfrld(ji,jj) ) )
+            iflt    = zinda  * (1 - i1mfr) * (1 - ifvt )
+            ial     = ifvt   * i1mfr + ( 1 - ifvt ) * idfr
+            iadv    = ( 1  - i1mfr ) * zinda
+            ifral   = ( 1  - i1mfr * ( 1 - ial ) )   
+            ifrdv   = ( 1  - ifral * ( 1 - ial ) ) * iadv 
+            !   computation the solar flux at ocean surface
+            zqsr    = pfrld(ji,jj) * qsr(ji,jj)  + ( 1. - pfrld(ji,jj) ) * fstric(ji,jj)
+            !  computation the non solar heat flux at ocean surface
+            zqns    =  - ( 1. - thcm(ji,jj) ) * zqsr   &   ! part of the solar energy used in leads
+               &       + iflt    * ( fscmbq(ji,jj) + ffltbif(ji,jj) )                            &
+               &       + ifral   * ( ial * qcmif(ji,jj) + (1 - ial) * qldif(ji,jj) ) / rdt_ice   &
+               &       + ifrdv   * ( qfvbq(ji,jj) + qdtcn(ji,jj) ) / rdt_ice
+
+            fsbbq(ji,jj) = ( 1.0 - ( ifvt + iflt ) ) * fscmbq(ji,jj)     ! ???
+            
+            qsr  (ji,jj) = zqsr                                          ! solar heat flux 
+            qns  (ji,jj) = zqns - fdtcn(ji,jj)                           ! non solar heat flux
+         END DO
+      END DO
+  
+      !------------------------------------------!
+      !      mass flux at the ocean surface      !
+      !------------------------------------------!
+
+!!gm
+!!gm CAUTION   
+!!gm re-verifies the emp & emps expression, especially the absence of 1-frld on zfm
+!!gm
+      DO jj = 1, jpj
+         DO ji = 1, jpi
+            
+            !  computing freshwater exchanges at the ice/ocean interface
+            zemp = + emp(ji,jj)     *         frld(ji,jj)      &   !  e-p budget over open ocean fraction 
+               &   - tprecip(ji,jj) * ( 1. -  frld(ji,jj) )    &   !  liquid precipitation reaches directly the ocean
+               &   + sprecip(ji,jj) * ( 1. - pfrld(ji,jj) )    &   !  taking into account change in ice cover within the time step
+               &   + rdmsnif(ji,jj) / rdt_ice                      !  freshwaterflux due to snow melting 
+               !                                                   !  ice-covered fraction:
+
+            !  computing salt exchanges at the ice/ocean interface
+            zfons =  ( soce - sice ) * ( rdmicif(ji,jj) / rdt_ice ) 
+            
+            !  converting the salt flux from ice to a freshwater flux from ocean
+            zfm  = zfons / ( sss_m(ji,jj) + epsi16 )
+            
+            emps(ji,jj) = zemp + zfm      ! surface ocean concentration/dilution effect (use on SSS evolution)
+            emp (ji,jj) = zemp            ! surface ocean volume flux (use on sea-surface height evolution)
+
+         END DO
+      END DO
+
+      IF( lk_dynspg_rl )    emp (:,:) = emps(:,:)      ! rigid-lid formulation : emp = emps
+
+      !------------------------------------------!
+      !    momentum flux at the ocean surface    !
+      !------------------------------------------!
+
+      IF ( ln_limdyn ) THEN                        ! Update the stress over ice-over area (only in ice-dynamic case)
+         !                                         ! otherwise the atmosphere-ocean stress is used everywhere
+
+         ! ... ice stress over ocean with a ice-ocean rotation angle (at I-point)
+!CDIR NOVERRCHK
+         DO jj = 1, jpj
+!CDIR NOVERRCHK
+            DO ji = 1, jpi
+               ! ... change the cosinus angle sign in the south hemisphere
+               zsang  = SIGN(1.e0, gphif(ji,jj) ) * sangvg
+               ! ... ice velocity relative to the ocean
+               zu_io  = ui_ice(ji,jj) - ui_oce(ji,jj)
+               zv_io  = vi_ice(ji,jj) - vi_oce(ji,jj)
+               zmod   = rhoco * SQRT( zu_io * zu_io + zv_io * zv_io )
+               ! ... ice stress over ocean with a ice-ocean rotation angle (at I-point)
+               ztio_u(ji,jj) = zmod * ( cangvg * zu_io - zsang * zv_io )
+               ztio_v(ji,jj) = zmod * ( cangvg * zv_io + zsang * zu_io )
+               ! 
+            END DO
+         END DO
+
+         DO jj = 2, jpjm1
+            DO ji = fs_2, fs_jpim1   ! vertor opt.
+               ! ... ice-cover wheighted ice-ocean stress at U and V-points  (from I-point values)
+               zutau  = 0.5 * ( ztio_u(ji+1,jj) + ztio_u(ji+1,jj+1) )
+               zvtau  = 0.5 * ( ztio_v(ji,jj+1) + ztio_v(ji+1,jj+1) )
+               ! ... open-ocean (lead) fraction at U- & V-points (from T-point values)
+               zfrldu = 0.5 * ( frld (ji,jj) + frld (ji+1,jj  ) )
+               zfrldv = 0.5 * ( frld (ji,jj) + frld (ji  ,jj+1) )
+               ! update surface ocean stress
+               utau(ji,jj) = zfrldu * utau(ji,jj) + ( 1. - zfrldu ) * zutau
+               vtau(ji,jj) = zfrldv * vtau(ji,jj) + ( 1. - zfrldv ) * zvtau
+               !
+            END DO
+         END DO
+
+         ! boundary condition on the stress (utau,vtau)
+         CALL lbc_lnk( utau, 'U', -1. )
+         CALL lbc_lnk( vtau, 'V', -1. )
+
+      ENDIF
+
+      !-----------------------------------------------!
+      !   Storing the transmitted variables           !
+      !-----------------------------------------------!
+
+      freeze(:,:) = 1.0 - frld(:,:)       ! Sea ice cover            
+      tn_ice(:,:) = sist(:,:)             ! Ice surface temperature                      
+
+#if defined key_coupled            
+      !------------------------------------------------!
+      !    Computation of snow/ice and ocean albedo    !
+      !------------------------------------------------!
+      zalb  (:,:) = 0.e0
+      zalbp (:,:) = 0.e0
+
+      CALL albedo_ice( sist, hicif, hsnif, zalbp, zalb )
+
+      alb_ice(:,:) =  0.5 * zalbp(:,:) + 0.5 * zalb (:,:)   ! Ice albedo (mean clear and overcast skys)
+#endif
+
+      IF(ln_ctl) THEN
+         CALL prt_ctl(tab2d_1=qsr   , clinfo1=' lim_sbc: qsr    : ', tab2d_2=qns   , clinfo2=' qns     : ')
+         CALL prt_ctl(tab2d_1=emp   , clinfo1=' lim_sbc: emp    : ', tab2d_2=emps  , clinfo2=' emps    : ')
+         CALL prt_ctl(tab2d_1=utau  , clinfo1=' lim_sbc: utau   : ', mask1=umask,   &
+            &         tab2d_2=vtau  , clinfo2=' vtau    : '        , mask2=vmask )
+         CALL prt_ctl(tab2d_1=freeze, clinfo1=' lim_sbc: freeze : ', tab2d_2=tn_ice, clinfo2=' tn_ice  : ')
+      ENDIF 
+   
+    END SUBROUTINE lim_sbc_2
+
+#else
+   !!----------------------------------------------------------------------
+   !!   Default option :        Dummy module       NO LIM 2.0 sea-ice model
+   !!----------------------------------------------------------------------
+CONTAINS
+   SUBROUTINE lim_sbc_2         ! Dummy routine
+   END SUBROUTINE lim_sbc_2
+#endif 
+
+   !!======================================================================
+END MODULE limsbc_2
Index: trunk/NEMO/LIM_SRC_2/limtab_2.F90
===================================================================
--- trunk/NEMO/LIM_SRC_2/limtab_2.F90	(revision 873)
+++ trunk/NEMO/LIM_SRC_2/limtab_2.F90	(revision 888)
@@ -21,6 +21,6 @@
    !!----------------------------------------------------------------------
    !!   LIM 2.0,  UCL-LOCEAN-IPSL (2005) 
-   !! $Header$ 
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
+   !! $ Id: $
+   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 CONTAINS
Index: trunk/NEMO/LIM_SRC_2/limthd_2.F90
===================================================================
--- trunk/NEMO/LIM_SRC_2/limthd_2.F90	(revision 873)
+++ trunk/NEMO/LIM_SRC_2/limthd_2.F90	(revision 888)
@@ -4,4 +4,8 @@
    !!              LIM thermo ice model : ice thermodynamic
    !!======================================================================
+   !! History :  1.0  !  00-01 (LIM)
+   !!            2.0  !  02-07 (C. Ethe, G. Madec) F90
+   !!            2.0  !  03-08 (C. Ethe)  add lim_thd_init
+   !!---------------------------------------------------------------------
 #if defined key_lim2
    !!----------------------------------------------------------------------
@@ -18,5 +22,6 @@
    USE ice_2           ! LIM sea-ice variables
    USE ice_oce         ! sea-ice/ocean variables
-   USE flx_oce         ! sea-ice/ocean forcings variables 
+   USE sbc_oce         ! 
+   USE sbc_ice         ! 
    USE thd_ice_2       ! LIM thermodynamic sea-ice variables
    USE dom_ice_2       ! LIM sea-ice domain
@@ -30,14 +35,11 @@
    PRIVATE
 
-   !! * Routine accessibility
-   PUBLIC lim_thd_2       ! called by lim_step_2
-
-   !! * Module variables
-   REAL(wp)  ::            &  ! constant values
-      epsi20 = 1.e-20   ,  &
-      epsi16 = 1.e-16   ,  &
-      epsi04 = 1.e-04   ,  &
-      zzero  = 0.e0     ,  &
-      zone   = 1.e0
+   PUBLIC   lim_thd_2  ! called by lim_step
+
+   REAL(wp)  ::   epsi20 = 1.e-20   ,  &  ! constant values
+      &           epsi16 = 1.e-16   ,  &
+      &           epsi04 = 1.e-04   ,  &
+      &           zzero  = 0.e0     ,  &
+      &           zone   = 1.e0
 
    !! * Substitutions
@@ -46,6 +48,6 @@
    !!-------- -------------------------------------------------------------
    !!   LIM 2.0,  UCL-LOCEAN-IPSL (2005) 
-   !! $Header$ 
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
+   !! $ Id: $
+   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -68,13 +70,8 @@
       !!             - back to the geographic grid
       !!
-      !! ** References :
-      !!       H. Goosse et al. 1996, Bul. Soc. Roy. Sc. Liege, 65, 87-90
-      !!
-      !! History :
-      !!   1.0  !  00-01 (LIM)
-      !!   2.0  !  02-07 (C. Ethe, G. Madec) F90
+      !! References :   Goosse et al. 1996, Bul. Soc. Roy. Sc. Liege, 65, 87-90
       !!---------------------------------------------------------------------
       INTEGER, INTENT(in) ::   kt     ! number of iteration
-
+      !!
       INTEGER  ::   ji, jj,    &   ! dummy loop indices
          nbpb  ,               &   ! nb of icy pts for thermo. cal.
@@ -92,12 +89,10 @@
          zfontn             ,  &   ! heat flux from snow thickness
          zfntlat, zpareff          ! test. the val. of lead heat budget
-      REAL(wp), DIMENSION(jpi,jpj) :: &
-         zhicifp            ,  &   ! ice thickness for outputs
-         zqlbsbq                   ! link with lead energy budget qldif
-      REAL(wp), DIMENSION(jpi,jpj,jpk) :: &
-         zmsk                      ! working array
+      REAL(wp), DIMENSION(jpi,jpj) ::   zhicifp,   &  ! ice thickness for outputs
+         &                              zqlbsbq       ! link with lead energy budget qldif
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zmsk      ! working array
       !!-------------------------------------------------------------------
 
-      IF( kt == nit000  )   CALL lim_thd_init_2  ! Initialization (first time-step only)
+      IF( kt == nit000 )   CALL lim_thd_init_2  ! Initialization (first time-step only)
    
       !-------------------------------------------!
@@ -173,4 +168,6 @@
       !--------------------------------------------------------------------------
 
+      sst_m(:,:) = sst_m(:,:) + rt0
+
       !CDIR NOVERRCHK
       DO jj = 1, jpj
@@ -188,11 +185,11 @@
             !  temperature and turbulent mixing (McPhee, 1992)
             zfric_u        = MAX ( MIN( SQRT( ust2s(ji,jj) ) , zfric_umax ) , zfric_umin )  ! friction velocity
-            fdtcn(ji,jj)  = zindb * rau0 * rcp * 0.006  * zfric_u * ( sst_io(ji,jj) - tfu(ji,jj) ) 
+            fdtcn(ji,jj)  = zindb * rau0 * rcp * 0.006  * zfric_u * ( sst_m(ji,jj) - tfu(ji,jj) ) 
             qdtcn(ji,jj)  = zindb * fdtcn(ji,jj) * frld(ji,jj) * rdt_ice
                         
             !  partial computation of the lead energy budget (qldif)
             zfontn         = ( sprecip(ji,jj) / rhosn ) * xlsn  !   energy for melting
-            zfnsol         = qnsr_oce(ji,jj)  !  total non solar flux
-            qldif(ji,jj)   = tms(ji,jj) * ( qsr_oce(ji,jj) * ( 1.0 - thcm(ji,jj) )   &
+            zfnsol         = qns(ji,jj)                         !  total non solar flux over the ocean
+            qldif(ji,jj)   = tms(ji,jj) * ( qsr(ji,jj) * ( 1.0 - thcm(ji,jj) )   &
                &                               + zfnsol + fdtcn(ji,jj) - zfontn     &
                &                               + ( 1.0 - zindb ) * fsbbq(ji,jj) )   &
@@ -206,5 +203,5 @@
             
             !  energy needed to bring ocean surface layer until its freezing
-            qcmif  (ji,jj) =  rau0 * rcp * fse3t(ji,jj,1) * ( tfu(ji,jj) - sst_io(ji,jj) ) * ( 1 - zinda )
+            qcmif  (ji,jj) =  rau0 * rcp * fse3t(ji,jj,1) * ( tfu(ji,jj) - sst_m(ji,jj) ) * ( 1 - zinda )
             
             !  calculate oceanic heat flux.
@@ -216,4 +213,5 @@
       END DO
       
+      sst_m(:,:) = sst_m(:,:) - rt0
       
       !         Select icy points and fulfill arrays for the vectorial grid.
@@ -258,5 +256,5 @@
          CALL tab_2d_1d_2( nbpb, fr1_i0_1d  (1:nbpb)     , fr1_i0     , jpi, jpj, npb(1:nbpb) )
          CALL tab_2d_1d_2( nbpb, fr2_i0_1d  (1:nbpb)     , fr2_i0     , jpi, jpj, npb(1:nbpb) )
-         CALL tab_2d_1d_2( nbpb, qnsr_ice_1d(1:nbpb)     , qnsr_ice   , jpi, jpj, npb(1:nbpb) )
+         CALL tab_2d_1d_2( nbpb, qns_ice_1d (1:nbpb)     , qns_ice    , jpi, jpj, npb(1:nbpb) )
 #if ! defined key_coupled
          CALL tab_2d_1d_2( nbpb, qla_ice_1d (1:nbpb)     , qla_ice    , jpi, jpj, npb(1:nbpb) )
@@ -404,5 +402,5 @@
          CALL prt_ctl(tab2d_1=qstoif, clinfo1=' lim_thd: qstoif  : ', tab2d_2=fsbbq , clinfo2=' fsbbq  : ')
       ENDIF
-
+       !
     END SUBROUTINE lim_thd_2
 
@@ -419,7 +417,4 @@
       !!
       !! ** input   :   Namelist namicether
-      !!
-      !! history :
-      !!  8.5  ! 03-08 (C. Ethe) original code
       !!-------------------------------------------------------------------
       NAMELIST/namicethd/ hmelt , hiccrit, hicmin, hiclim, amax  ,        &
Index: trunk/NEMO/LIM_SRC_2/limthd_lac_2.F90
===================================================================
--- trunk/NEMO/LIM_SRC_2/limthd_lac_2.F90	(revision 873)
+++ trunk/NEMO/LIM_SRC_2/limthd_lac_2.F90	(revision 888)
@@ -30,5 +30,5 @@
    !!----------------------------------------------------------------------
    !!   LIM 2.0,  UCL-LOCEAN-IPSL (2005) 
-   !! $Header$ 
+   !! $ Id: $
    !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
    !!----------------------------------------------------------------------
